FFOO
====

SYNOPSIS
--------

    #!/bin/bash
    # ~/bin/example
    . <(ffoom init)
    ffoo import core

    # basic echo helpers
    think "about saying something..."   # thinks loud if FFOO_VERBOSE
    warn "this is just an example"      # obvious :)
    false || die "false was true!"      # Perlism :)
    x=1; y=2; z=3
    debug "x=$x" "y=$y" "z=$z"          # debug:example: x=1
                                        # debug:example: y=2
                                        # debug:example: z=3
    debug -v x y z                      # << short for ^
    echo "hello" | debug_pipe mypipe    # debug|mypipe| hello
    warn -f should_be_empty             # warns with name+content
                                        # unless the file is empty


    # more advanced functions
    ffoo import ini
    FFOO_DATADIR=$HOME/.example
    cat >$FFOO_DATADIR/foo.ini <<EOF
    # a sample ini file
    [foo]
        multiline = also possible
        multiline = like this :)
    [foo.bar]
        baz = qux
    [py]
        s1 =#!/usr/bin/python
        s1 =def main():
        s1 =    print "will work!"
    EOF
    iniread -s foo.bar -k baz foo.ini       # prints "qux"
    iniread -p foo.bar.baz foo.ini          # ...short for above
    iniread -p foo.bar.baz                  # ...even shorter
    iniread -S -p py.s1 > s1.py foo.ini     # the -S will preserve spaces on RHS so
    python s1.py                            # << will work


    # even more
    ffoo import flow
    wait_until -e ! test -e badfile         # -e means use eval (make "!" work)
    think "the badfile is away..."
    bad_file_away() {                       # but you can avoid eval
        ! test -f badfile
    }
    wait_until bad_file_away

    # ... and more
    ffoo import testing
    register_artifact future.log            # does not need to exist yet
    myprog > future.log
    collect_artifacts                       # will preserve tree from /


    # ...AND MORE!
    ffoo import sw
    cat > deps.ini <<EOF
    [needs.now]
        yum = ronn
        yum = vim
        pypi = docopt
    [needs.for_test]
        cpan = Test::More
    # yeah I made that up
    EOF
    iniread -s needs.now ./deps.ini | any_install
    iniread -s needs.for_test ./deps.ini | any_install


AUTHOR
------

Alois Mahdal
